using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Drawing.Text;
using System.IO;
using System.IO.IsolatedStorage;
using System.Net;
using System.Security;
using System.Security.Permissions;
using System.Windows.Forms;
using System.Xml.Serialization;
using GrBoardClient.localhost;

namespace GrBoardClient
{
	/// <summary>
	/// `c[B
	/// </summary>
	public class DrawForm : System.Windows.Forms.Form
	{
		private Point lastPoint;
		private Color currentColor;
		private delegate void ButtonCommand();

		private GraphicsPath currentPath;
		private ArrayList paths;
		private ArrayList undoPaths;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.ContextMenu contextMenu;
		private System.Windows.Forms.MenuItem menuRetry;
		private System.Windows.Forms.MenuItem menuClear;
		private System.Windows.Forms.MenuItem menuUndo;
		private System.Windows.Forms.TextBox textBox;
		private System.Windows.Forms.MenuItem menuText;
		private System.Windows.Forms.FontDialog fontDialog;
		private System.Windows.Forms.ToolBar toolBar;
		private System.Windows.Forms.ToolBarButton toolBarClear;
		private System.Windows.Forms.ToolBarButton toolBarFont;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBarButton toolBarUndo;
		private System.Windows.Forms.ToolBarButton toolBarRedo;
		private System.Windows.Forms.ToolBarButton toolBarSep1;
		private System.Windows.Forms.ToolBarButton toolBarSep0;
		private System.Windows.Forms.ToolBarButton toolBarSep2;
		private System.Windows.Forms.ToolBarButton toolBarSaveAs;
		private System.Windows.Forms.Button submitButton;
		private System.Windows.Forms.TextBox textSubject;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		private System.Windows.Forms.Label labelUrl;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textAuthor;
		private System.Windows.Forms.ColorDialog colorDialog;
		private System.Windows.Forms.MenuItem menuItemColor;
		private System.Windows.Forms.ToolBarButton toolBarColor;
		private System.ComponentModel.IContainer components;

		public DrawForm()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
			lastPoint = new Point(0, 0);
			paths = new ArrayList();
			undoPaths = new ArrayList();

			toolBarClear.Tag = new ButtonCommand(clear);
			toolBarFont.Tag = new ButtonCommand(changeFont);
			toolBarUndo.Tag = new ButtonCommand(undo);	
			toolBarUndo.Enabled = false;
			toolBarRedo.Tag = new ButtonCommand(redo);
			toolBarRedo.Enabled = false;
			toolBarSaveAs.Tag = new ButtonCommand(saveImage);
			toolBarColor.Tag = new ButtonCommand(changeColor);

			FileDialogPermission fd = new FileDialogPermission(FileDialogPermissionAccess.Save);
			try 
			{
				fd.Demand();
			}
			catch (SecurityException)
			{
				toolBarSaveAs.Enabled = false;
			}
			currentColor = Color.Black;

			try
			{
				using (StreamReader sr = new StreamReader(new IsolatedStorageFileStream("GrBoardDraw", FileMode.Open)))
				{
					string s = sr.ReadLine();
					if (s != null)
					{
						textAuthor.Text = s;
					}
				}
			}
			catch (FileNotFoundException)
			{
			}
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DrawForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.contextMenu = new System.Windows.Forms.ContextMenu();
			this.menuUndo = new System.Windows.Forms.MenuItem();
			this.menuRetry = new System.Windows.Forms.MenuItem();
			this.menuText = new System.Windows.Forms.MenuItem();
			this.menuClear = new System.Windows.Forms.MenuItem();
			this.menuItemColor = new System.Windows.Forms.MenuItem();
			this.submitButton = new System.Windows.Forms.Button();
			this.textBox = new System.Windows.Forms.TextBox();
			this.fontDialog = new System.Windows.Forms.FontDialog();
			this.toolBar = new System.Windows.Forms.ToolBar();
			this.toolBarSep0 = new System.Windows.Forms.ToolBarButton();
			this.toolBarClear = new System.Windows.Forms.ToolBarButton();
			this.toolBarSaveAs = new System.Windows.Forms.ToolBarButton();
			this.toolBarSep1 = new System.Windows.Forms.ToolBarButton();
			this.toolBarUndo = new System.Windows.Forms.ToolBarButton();
			this.toolBarRedo = new System.Windows.Forms.ToolBarButton();
			this.toolBarSep2 = new System.Windows.Forms.ToolBarButton();
			this.toolBarFont = new System.Windows.Forms.ToolBarButton();
			this.toolBarColor = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.textSubject = new System.Windows.Forms.TextBox();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.labelUrl = new System.Windows.Forms.Label();
			this.textAuthor = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.colorDialog = new System.Windows.Forms.ColorDialog();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Location = new System.Drawing.Point(24, 72);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(600, 400);
			this.panel1.TabIndex = 1;
			this.panel1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseUp);
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			this.panel1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseMove);
			this.panel1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
			// 
			// contextMenu
			// 
			this.contextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuUndo,
																						this.menuRetry,
																						this.menuText,
																						this.menuClear,
																						this.menuItemColor});
			this.contextMenu.Popup += new System.EventHandler(this.contextMenu_Popup);
			// 
			// menuUndo
			// 
			this.menuUndo.Index = 0;
			this.menuUndo.Text = "ɖ߂(&U)";
			this.menuUndo.Click += new System.EventHandler(this.menuUndo_Click);
			// 
			// menuRetry
			// 
			this.menuRetry.Index = 1;
			this.menuRetry.Text = "蒼(&R)";
			this.menuRetry.Click += new System.EventHandler(this.menuRetry_Click);
			// 
			// menuText
			// 
			this.menuText.Index = 2;
			this.menuText.Text = "(&T)";
			this.menuText.Click += new System.EventHandler(this.menuText_Click);
			// 
			// menuClear
			// 
			this.menuClear.Index = 3;
			this.menuClear.Text = "S(&C)";
			this.menuClear.Click += new System.EventHandler(this.menuClear_Click);
			// 
			// menuItemColor
			// 
			this.menuItemColor.Index = 4;
			this.menuItemColor.Text = "Fݒ";
			this.menuItemColor.Click += new System.EventHandler(this.menuItemColor_Click);
			// 
			// submitButton
			// 
			this.submitButton.Location = new System.Drawing.Point(264, 488);
			this.submitButton.Name = "submitButton";
			this.submitButton.Size = new System.Drawing.Size(128, 24);
			this.submitButton.TabIndex = 2;
			this.submitButton.Text = "o^";
			this.submitButton.Click += new System.EventHandler(this.submitButton_Click);
			// 
			// textBox
			// 
			this.textBox.BackColor = System.Drawing.Color.Gainsboro;
			this.textBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.textBox.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.textBox.Font = new System.Drawing.Font("MS UI Gothic", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.textBox.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(128)), ((System.Byte)(64)), ((System.Byte)(0)));
			this.textBox.Location = new System.Drawing.Point(16, 488);
			this.textBox.Multiline = true;
			this.textBox.Name = "textBox";
			this.textBox.Size = new System.Drawing.Size(128, 24);
			this.textBox.TabIndex = 3;
			this.textBox.Text = "";
			this.textBox.Visible = false;
			this.textBox.WordWrap = false;
			this.textBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBox_KeyDown);
			// 
			// toolBar
			// 
			this.toolBar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.toolBarSep0,
																					   this.toolBarClear,
																					   this.toolBarSaveAs,
																					   this.toolBarSep1,
																					   this.toolBarUndo,
																					   this.toolBarRedo,
																					   this.toolBarSep2,
																					   this.toolBarFont,
																					   this.toolBarColor});
			this.toolBar.DropDownArrows = true;
			this.toolBar.ImageList = this.imageList1;
			this.toolBar.Location = new System.Drawing.Point(0, 0);
			this.toolBar.Name = "toolBar";
			this.toolBar.ShowToolTips = true;
			this.toolBar.Size = new System.Drawing.Size(648, 28);
			this.toolBar.TabIndex = 4;
			this.toolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_ButtonClick);
			// 
			// toolBarSep0
			// 
			this.toolBarSep0.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarClear
			// 
			this.toolBarClear.ImageIndex = 4;
			this.toolBarClear.ToolTipText = "VK쐬";
			// 
			// toolBarSaveAs
			// 
			this.toolBarSaveAs.ImageIndex = 5;
			this.toolBarSaveAs.ToolTipText = "Otĕۑ";
			// 
			// toolBarSep1
			// 
			this.toolBarSep1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarUndo
			// 
			this.toolBarUndo.ImageIndex = 1;
			this.toolBarUndo.ToolTipText = "ɖ߂";
			// 
			// toolBarRedo
			// 
			this.toolBarRedo.ImageIndex = 2;
			this.toolBarRedo.ToolTipText = "蒼";
			// 
			// toolBarSep2
			// 
			this.toolBarSep2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarFont
			// 
			this.toolBarFont.ImageIndex = 3;
			this.toolBarFont.ToolTipText = "tHgݒ";
			// 
			// toolBarColor
			// 
			this.toolBarColor.ImageIndex = 6;
			this.toolBarColor.ToolTipText = "FI";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// textSubject
			// 
			this.textSubject.Location = new System.Drawing.Point(80, 40);
			this.textSubject.Name = "textSubject";
			this.textSubject.Size = new System.Drawing.Size(256, 19);
			this.textSubject.TabIndex = 0;
			this.textSubject.Text = "";
			// 
			// saveFileDialog
			// 
			this.saveFileDialog.Filter = "PNGt@C|*.png|ׂẴt@C|*.*";
			// 
			// labelUrl
			// 
			this.labelUrl.Location = new System.Drawing.Point(400, 488);
			this.labelUrl.Name = "labelUrl";
			this.labelUrl.Size = new System.Drawing.Size(240, 24);
			this.labelUrl.TabIndex = 5;
			// 
			// textAuthor
			// 
			this.textAuthor.Location = new System.Drawing.Point(464, 40);
			this.textAuthor.Name = "textAuthor";
			this.textAuthor.Size = new System.Drawing.Size(160, 19);
			this.textAuthor.TabIndex = 1;
			this.textAuthor.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(424, 44);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 16);
			this.label1.TabIndex = 7;
			this.label1.Text = "O";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(32, 44);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 24);
			this.label2.TabIndex = 8;
			this.label2.Text = "^Cg";
			// 
			// DrawForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(648, 523);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textAuthor);
			this.Controls.Add(this.textSubject);
			this.Controls.Add(this.textBox);
			this.Controls.Add(this.labelUrl);
			this.Controls.Add(this.toolBar);
			this.Controls.Add(this.submitButton);
			this.Controls.Add(this.panel1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "DrawForm";
			this.Text = "GrClient";
			this.Closed += new System.EventHandler(this.DrawForm_Closed);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new DrawForm());
		}

		private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				currentPath = new GraphicsPath();
			}
		}

		private void panel1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				lastPoint.X = e.X;
				lastPoint.Y = e.Y;
				contextMenu.Show(panel1, lastPoint);
			} 
			else if (e.Button == MouseButtons.Left)
			{
				if (currentPath != null)
				{
					if (currentPath.PointCount > 0)
					{
						paths.Add(new PathHolder(currentPath, currentColor));
						toolBarUndo.Enabled = true;
					}
					currentPath = null;
					panel1.Invalidate(false);
				}
				Commit();
			}
		}

		private void panel1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (currentPath != null) 
			{
				currentPath.AddLine(e.X, e.Y, e.X, e.Y);
				using (Graphics g = panel1.CreateGraphics())
				{
					g.DrawPath(Pens.Chocolate, currentPath);
				}
			}
		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			foreach (PathHolder p in paths)
			{
				p.Draw(e.Graphics);
			}
			if (currentPath != null) 
			{
				e.Graphics.DrawPath(Pens.Chocolate, currentPath);
			}
		}

		private void menuClear_Click(object sender, System.EventArgs e)
		{
			clear();
		}

		private void clear()
		{
			paths.Clear();
			undoPaths.Clear();
			currentPath = null;
			toolBarUndo.Enabled = false;
			toolBarRedo.Enabled = false;
			panel1.Invalidate();
		}

		private void menuUndo_Click(object sender, System.EventArgs e)
		{
			undo();
		}

		private void undo()
		{
			if (paths.Count > 0) 
			{
				exchangePath(paths, undoPaths);
			}
			toolBarRedo.Enabled = (undoPaths.Count > 0);
			toolBarUndo.Enabled = (paths.Count > 0);
		}

		private void menuRetry_Click(object sender, System.EventArgs e)
		{
			redo();
		}

		private void redo()
		{
			if (undoPaths.Count > 0) 
			{
				exchangePath(undoPaths, paths);
			}
			toolBarRedo.Enabled = (undoPaths.Count > 0);
			toolBarUndo.Enabled = (paths.Count > 0);
		}

		private void menuFont_Click(object sender, System.EventArgs e)
		{
			changeFont();
		}

		private void changeFont()
		{
			if (fontDialog.ShowDialog(this) == DialogResult.OK)
			{
				textBox.Font = fontDialog.Font;
			}
		}

		private void menuItemColor_Click(object sender, System.EventArgs e)
		{
			changeColor();
		}

		private void changeColor()
		{
			if (colorDialog.ShowDialog(this) == DialogResult.OK)
			{
				currentColor = colorDialog.Color;
			}
		}

		private void exchangePath(ArrayList src, ArrayList dst)
		{
			int i = src.Count - 1;
			Object o = src[i];
			src.RemoveAt(i);
			dst.Add(o);
			panel1.Invalidate();
		}

		private void contextMenu_Popup(object sender, System.EventArgs e)
		{
			menuUndo.Enabled = (paths.Count > 0);
			menuRetry.Enabled = (undoPaths.Count > 0);
		}

		private void saveImage()
		{
			Commit();

			FileDialogPermission fd = new FileDialogPermission(FileDialogPermissionAccess.Save);
			try 
			{
				fd.Demand();
			}
			catch (SecurityException)
			{
				return;
			}

			if (saveFileDialog.ShowDialog(this) == DialogResult.OK)
			{
				using (Bitmap b = new Bitmap(panel1.Width, panel1.Height))
				{
					using (Graphics gr = Graphics.FromImage(b))
					{
						gr.Clear(Color.White);
						foreach (PathHolder ph in paths)
						{
							ph.Draw(gr);
						}
						gr.Flush();
					}
					using (Stream stm = saveFileDialog.OpenFile())
					{
						b.Save(stm, ImageFormat.Png);
					}
				}
			}
		}

		private void menuText_Click(object sender, System.EventArgs e)
		{
			Point textLoc = lastPoint;
			textLoc.Offset(panel1.Left, panel1.Top);
			textBox.Location = textLoc;
			textBox.Width = panel1.Width - lastPoint.X;
			textBox.Height = panel1.Height - lastPoint.Y;
			textBox.Visible = true;
			UIPermission uip = new UIPermission(UIPermissionWindow.AllWindows);
			try
			{
				uip.Demand();
				textBox.Focus();
			}
			catch (SecurityException)
			{
			}
		}

		private void textBox_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)
			{
				textFinished();
			}
		}

		private void textFinished()
		{
			String[] s = textBox.Lines;
			textBox.Clear();
			textBox.Visible = false;
			GraphicsPath gp = new GraphicsPath();
			System.Drawing.PointF pnt = textBox.Location;
			pnt -= new Size(panel1.Left, panel1.Top);
			TextHolder th = new TextHolder(textBox.Font, currentColor);
			using (Graphics g = panel1.CreateGraphics())
			{
				for (int i = 0; i < s.Length; i++)
				{
					using (Brush b = new SolidBrush(currentColor))
					{
						g.DrawString(s[i], textBox.Font, b, pnt);
						th.addString(s[i], pnt);
						pnt.Y += textBox.Font.Height;
					}
				}
			}
			paths.Add(th);
			toolBarUndo.Enabled = true;
		}

		private void toolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			ButtonCommand b = (ButtonCommand)e.Button.Tag;
			b();
		}

		private void submitButton_Click(object sender, System.EventArgs e)
		{
			Commit();
			ArrayList a = new ArrayList();
			foreach (PathHolder p in paths)
			{
				p.GetElement(a);
			}

			ImageElement[] elms = new ImageElement[a.Count];
			a.CopyTo(elms);
			Contribution contrib = new Contribution();
			contrib.Height = panel1.Height;
			contrib.Width = panel1.Width;
			contrib.Elements = elms;
			contrib.Subject = textSubject.Text;
			contrib.Author = textAuthor.Text;

			using (ContributionService svc = getService())
			{
				try 
				{
					Message("o^Jn");
					int key = svc.Reserve();
					if (key < 0)
					{
						Warn("݁Ał܂");
					}
					else
					{
						Message("o^");
						((Contributor)svc).Last = true;
						svc.Register(key, contrib);
						Message("o^-uEUXVĂ");
					}
				}
				catch (WebException ex)
				{
					Warn(ex.Message);
				}
			}
		}

		private void Warn(string msg)
		{
			labelUrl.ForeColor = Color.Red;
			labelUrl.Text = msg;
		}

		private void Message(string msg)
		{
			labelUrl.ForeColor = Color.Black;
			labelUrl.Text = msg;
			labelUrl.Refresh();
		}

		private ContributionService getService()
		{
			Contributor svc = new Contributor();
			Uri uri = new Uri(AppDomain.CurrentDomain.BaseDirectory);
			if (uri.Host != String.Empty)
			{
				svc.Url = AppDomain.CurrentDomain.BaseDirectory + "ContributionService.asmx";
				Message(svc.Url);
			}
			return svc;
		}

		internal static GrBoardClient.localhost.PointF[] ConvertPointF(ICollection src)
		{
			GrBoardClient.localhost.PointF[] pts = new GrBoardClient.localhost.PointF[src.Count];
			int i = 0;
			foreach (System.Drawing.PointF p in src)
			{
				pts[i] = new GrBoardClient.localhost.PointF();
				pts[i].X = p.X;
				pts[i].Y = p.Y;
				i++;
			}
			return pts;
		}

		private void Commit()
		{
			if (textBox.Visible)
			{
				textFinished();
			}
		}

		// eҖۑB
		private void DrawForm_Closed(object sender, System.EventArgs e)
		{
			using (StreamWriter sw = new StreamWriter(new IsolatedStorageFileStream("GrBoardDraw", FileMode.Create)))
			{
				sw.WriteLine(textAuthor.Text);
			}
		}


		private class Contributor : ContributionService 
		{
			bool last;
			internal Contributor()
			{
				last = false;
			}
			protected override WebRequest GetWebRequest(Uri uri)
			{
				HttpWebRequest wr = (HttpWebRequest)WebRequest.Create(uri);
				if (last)
				{
					wr.KeepAlive = false;
				}
				return wr;
			}
			internal bool Last
			{
				get
				{
					return last;
				}
				set
				{
					last = value;
				}
			}
		}
	}

	class PathHolder
	{
		protected GraphicsPath gpath;
		protected Color color;
		protected PathHolder(Color c)
		{
			color = c;
		}
		internal PathHolder(GraphicsPath g, Color c)
		{
			gpath = g;
			color = c;
		}
		internal virtual void Draw(Graphics g)
		{
			using (Pen pen = new Pen(color))
			{
				g.DrawPath(pen, gpath);
			}
		}
		internal virtual void GetElement(ArrayList a)
		{
			Line l = new Line();
			l.Points = DrawForm.ConvertPointF(gpath.PathPoints);
			l.ColorArgb = color.ToArgb();
			a.Add(l);
		}
	}

	class TextHolder : PathHolder
	{
		Font font;
		ArrayList texts;
		ArrayList points;
		internal TextHolder(Font f, Color c)
			: base(c)
		{
			font = f;
			points = new ArrayList();
			texts = new ArrayList();
		}
		internal void addString(String s, System.Drawing.PointF p)
		{
			points.Add(p);
			texts.Add(s);
		}
		internal override void Draw(Graphics g)
		{
			using (Brush b = new SolidBrush(color))
			{
				for (int i = 0; i < texts.Count; i++)
				{
					g.DrawString((String)texts[i], font, b, (System.Drawing.PointF)points[i]);
				}
			}
		}
		internal override void GetElement(ArrayList a)
		{
			Text t = new Text();
			t.ColorArgb = color.ToArgb();
			t.Points = DrawForm.ConvertPointF(points);
			string[] s = new string[texts.Count];
			texts.CopyTo(s);
			t.Texts = s;
			FontValue v = new FontValue();
			v.FontFamily = font.FontFamily.Name;
			v.GdiCharSet = font.GdiCharSet;
			v.GdiVerticalFont = font.GdiVerticalFont;
			v.Height = font.Height;
			v.Name = font.Name;
			v.Size = font.Size;
			v.Style = (int)font.Style;
			v.Unit = (int)font.Unit;
			t.Font = v;
			a.Add(t);
		}

	}
}
